function [x,fx,gx,numfg,normgradhistory] = optimize(fg,init,alg,kwargs)
    if ~isfield(kwargs,'scale')
        kwargs.scale = @defaultscale;
    end

    if ~isfield(kwargs,'retract')
        kwargs.retract = @defaultretract;
    end

    if ~isfield(kwargs,'inner')
        kwargs.inner = @defaultinner;
    end

    [x, fx, gx, numfg, normgradhistory] = jl.mex('mexed_optimize',fg,init,alg,kwargs.scale,kwargs.retract,kwargs.inner);

end

function [v] = defaultscale(v,a)
    v = v*double(a);
end

function [nv,ng] = defaultretract(x,g,n)
    nv = x + g*double(n);
    ng = g;
end

function [s] = defaultinner(x,v,w)
    s = dot(v,w);
end
